#ifndef _CLIARG_H_
#define _CLIARG_H_

enum arg_type
{
    ARG_TYPE_NONE   = 0,
    ARG_TYPE_INT    = 1,
    ARG_TYPE_STRING = 2
};

/* argument handle */
struct arg_handle
{
    char short_name;
    char long_name[16];
    char description[128];
    enum arg_type type;
    union
    {
        int integer;
        char *string;
    } val;
    int is_set;
    int optional;
};

void arg_print_usage(struct arg_handle *arg_handles, int arg_num, FILE *fp);
int arg_get_arguments(struct arg_handle *arg_handles, int arg_num, int argc, char *argv[]);
void arg_release_arguments(struct arg_handle *arg_handles, int arg_num);

#endif /* _CLIARG_H_ */
