#ifndef __SCAN_H__
#define __SCAN_H__

//#include <QMainWindow>
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <linux/usb/ch9.h>
#include <linux/usbdevice_fs.h>
#include <asm/byteorder.h>
#include <sys/ioctl.h>
#include <errno.h>

#include <fcntl.h>
#include <locale.h>
#include <stdbool.h>

#include "define.h"

//#define CMD_TIMEOUT					100
#pragma pack(1)
typedef struct _IO_BLOCK_GL
{
    unsigned char bRequest;              // Specific request
    unsigned char bmRequestType;         // Bitmap - charateristics of request
    unsigned char fTransferDirectionIn;  // TRUE - Device-->Host; FALSE - Host-->Device
    unsigned short wValue;
    unsigned short wIndex;
    unsigned short wLength;

    unsigned char bData[1];
} IO_BLOCK_GL, *PIO_BLOCK_GL;
#pragma pack()

typedef struct _DEV_INFO_GL
{
    int m_fdev;
    __u16 vid;
    __u16 pid;
    __le16 bcdUSB;
    __le16 bcdDevice;
} DEV_INFO_GL, *PDEV_INFO_GL;

int send_control_cmd(int fdev,
                     __u8 type,
                     __u8 request,
                     __u16 value,
                     __u16 index,
                     __u16 length,
                     __u32 timeout,
                     void *data,
                     bool isvendor);

int GetDescriptor_Device(int fdev, int len, void *buf);
int GetDescriptor_String(int fdev, int index, int len, void *buf);

int SendVendorCommand(int fdev, bool dirIn, __u8 bRequest, __u16 wValue, __u16 wIndex, int len, void *buf);

int check_vidpid(char *devf_path);

#endif
